(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['module', 'exports', 'babel-runtime/core-js/set', './providers/index'], factory);
  } else if (typeof exports !== "undefined") {
    factory(module, exports, require('babel-runtime/core-js/set'), require('./providers/index'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod, mod.exports, global.set, global.index);
    global.Lint = mod.exports;
  }
})(this, function (module, exports, _set, _index) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = Validate;

  var _set2 = _interopRequireDefault(_set);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  // @HACK: This is just for testing purposes. Its used to mimic the actual
  //        'polyfill' property that will eventually be user configurable. Its
  //        hardcoded for now
  var tempPolyfills = new _set2.default();

  /**
   * Return false if a if a rule fails
   */

  function Validate(eslintNode) {
    var targets = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ['chrome', 'firefox', 'safari', 'edge'];

    // Find the corresponding rules for a eslintNode by it's ASTNodeType
    return _index.rules.filter(function (rule
    // Validate ASTNodeType
    ) {
      return rule.ASTNodeType === eslintNode.type &&
      // Check if polyfill is provided
      !tempPolyfills.has(rule.id);
    }).every(function (rule) {
      return rule.isValid(rule, eslintNode, targets);
    });
  }
  module.exports = exports['default'];
});